import os
import importlib
import inspect

class EntityRegistry:

    _entities = {}

    _dtos = {}

    def entity_for(self, entity_name: str):
        if len(self._entities)==0:
            for files in os.listdir(os.path.join(os.path.dirname(__file__), 'entity')):
            #for files in os.listdir(f"{os.getcwd()}/entity/"):
                if files.endswith('.py') and files!='__init__.py':
                    nome_modulo = f'nsj_integracao_api_entidades.entity.{files[:-3]}'
                    modulo = importlib.import_module(nome_modulo)
                    for _nome, _classe in inspect.getmembers(modulo, inspect.isclass):
                        if _classe.__module__ == nome_modulo:
                            self._entities[files[:-3].replace('_','.')] = _classe

        _classe = self._entities.get(entity_name)
        if _classe is None:
            raise KeyError(f"Não existe uma Entidade correpondente a tabela {entity_name}")

        return _classe

    def dto_for(self, entity_name: str):
        if len(self._dtos)==0:
            #for files in os.listdir(f"{os.getcwd()}/dto/"):
            for files in os.listdir(os.path.join(os.path.dirname(__file__), 'dto')):
                if files.endswith('.py') and files!='__init__.py':
                    nome_modulo = f'nsj_integracao_api_entidades.dto.{files[:-3]}'
                    modulo = importlib.import_module(nome_modulo)
                    for _nome, _classe in inspect.getmembers(modulo, inspect.isclass):
                        if _classe.__module__ == nome_modulo:
                            self._dtos[files[:-3].replace('_','.')] = _classe

        _classe = self._dtos.get(entity_name)
        if _classe is None:
            raise KeyError(f"Não existe um DTO correpondente a tabela {entity_name}")

        return _classe